/* first create by zhang.ruikang, thanks layui */

layui.use(['element', 'form', 'table'], function(){
    var $ = layui.$;
    var element = layui.element;
    var form = layui.form;
    var table = layui.table;
    var api  = "/cgi-bin/App/opser/netcheck";

    form.verify({
        isipaddr: function(value, item){
            if(!IsIPAddr(value))
                return "IPַʽ";
        }
    });
    
    form.on('select(check_type)', function(data){
        if(data.value=="auto")
            $("#sleeptime_box").show();
        else
            $("#sleeptime_box").hide();
    });
    
    form.on('submit(netcheck_form_submit)', function(data){
        if(data.field.check_type=="auto") {
            var num = data.field.sleeptime
            if(!IsDigit(num)) {
                layer.msg("", {icon:2, anim:6});
                return false;
            }
            if(Number(num)<1 || Number(num)>48) {
                layer.msg("Χ1-48", {icon:2, anim:6});
                return false;
            }
        }
        layer.confirm('ȷҪύ', {icon: 3, title:"ʾ"}, 
        function(index) {
            var load = layer.load(1, {shade: [0.1,'#fff']}, {time: 10*1000});
            data.field.action = "netcheck_set";
            $.ajax({
                url: api,
                type: 'POST',
                dataType: 'json',
                data:data.field,
                error: function(xhr, type){
                    layer.closeAll();
                    layer.msg("", {icon:2, anim:6});
                },
                success: function(data){
                    layer.closeAll();
                    if(data.code != 0)
                        layer.msg(data.msg, {icon:2, anim:6});
                    else {
                        layer.msg(data.msg, {icon:1});
                        loadRet();
                    }
                },
            });
        });
        return false;
    });

    function loadConf() {
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:{"action": "netcheck_loadconf"},
            error: function(xhr, type){},
            success: function(data){
                form.val("netcheck_form", { 
                    "check_type": data.data.check_type,
                    "sleeptime": data.data.sleeptime
                });
                if(data.data.check_type=="auto")
                    $("#sleeptime_box").show();
                else
                    $("#sleeptime_box").hide();
                form.render();
            },
        });
    }
    
    function loadRet() {
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:{"action": "netcheck_loadret"},
            error: function(xhr, type){},
            success: function(data){
                document.getElementById("showResult_box").innerHTML = "";
                
                if(data.msg != "have_msg") {
                    var box = document.createElement("div");
                    box.setAttribute('class', 'layui-row');
                    box.innerHTML = data.data[0];
                    document.getElementById("showResult_box").appendChild(box);
                    return;
                }
                
                var ret = data.data;
                
                //SHOW CHECK TIME
                var box = document.createElement("div");
                box.setAttribute('class', 'layui-row');
                box.setAttribute('style', 'width:50%;color:#444');
                box.innerHTML = "1. ʱ䣺" + ret.time;
                document.getElementById("showResult_box").appendChild(box);
                
                //SHOW DNS table
                box = document.createElement("div");
                box.setAttribute('class', 'layui-row');
                box.setAttribute('style', 'width:50%;color:#444');
                box.innerHTML = "2. TOP DNS";
                document.getElementById("showResult_box").appendChild(box);
                
                box = document.createElement("div");
                var tab = document.createElement("table");
                tab.setAttribute("class", "netcheckTab");
                
                //tab head
                var pos = 0;
                trow = tab.insertRow(-1);
                cell = trow.insertCell(pos++); 
                cell.setAttribute("style", "width:50px");
                cell.innerHTML = "";

                cell = trow.insertCell(pos++); 
                cell.setAttribute("style", "width:150px;");
                cell.innerHTML = "DNSIP";
                
                cell = trow.insertCell(pos++); 
                cell.setAttribute("style", "width:100px");
                cell.innerHTML = "";
                
                for(var i = 0; i < ret.dnscnt.length; i++){                
                    _dns = ret.dnscnt[i];

                    var pos = 0;
                    trow = tab.insertRow(-1);
                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = i+1;

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _dns.ip;

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _dns.cnt+"";                 
                }
                box.appendChild(tab);
                document.getElementById("showResult_box").appendChild(box);
                
                //NPM table
                for(var i = 0; i < ret.npmdata.length; i++){
                    var _npm = ret.npmdata[i];
                    
                    box = document.createElement("div");
                    box.setAttribute('class', 'layui-row');
                    box.setAttribute('style', 'width:50%;color:#444');
                    box.innerHTML = i + 3 + " NPM " + _npm.title;
                    document.getElementById("showResult_box").appendChild(box);
                    
                    box = document.createElement("div");
                    var tab = document.createElement("table");
                    tab.setAttribute("lay-filter", "tab_npmdata"+i);
                    tab.setAttribute("class", "netcheckTab");
                    
                    //tab head
                    var pos = 0;
                    trow = tab.insertRow(-1);
                    cell = trow.insertCell(pos++); 
                    cell.setAttribute("lay-data", "{field:'type'}");
                    cell.setAttribute("style", "width:100px");
                    cell.innerHTML = "ʱ";

                    cell = trow.insertCell(pos++); 
                    cell.setAttribute("lay-data", "{field:'ct'}");
                    cell.setAttribute("style", "width:100px");
                    cell.innerHTML = "ʱ";
                    
                    cell = trow.insertCell(pos++); 
                    cell.setAttribute("lay-data", "{field:'st'}");
                    cell.setAttribute("style", "width:100px");
                    cell.innerHTML = "Сʱ";

                    cell = trow.insertCell(pos++); 
                    cell.setAttribute("lay-data", "{field:'at'}");
                    cell.setAttribute("style", "width:100px");
                    cell.innerHTML = "ƽʱ";

                    cell = trow.insertCell(pos++); 
                    cell.setAttribute("lay-data", "{field:'ret'}");
                    cell.setAttribute("style", "width:100px");
                    cell.innerHTML = "";
                    
                    //ct
                    var pos = 0;
                    trow = tab.insertRow(-1);
                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = "ͻʱ";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.ct.max + "ms";
                    
                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.ct.min + "ms";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.ct.avg + "ms";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.ct.ret;
              
                    //st
                    var pos = 0;
                    trow = tab.insertRow(-1);
                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = "ʱ";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.st.max + "ms";
                    
                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.st.min + "ms";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.st.avg + "ms";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.st.ret;

                    //at
                    var pos = 0;
                    trow = tab.insertRow(-1);
                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = "Ӧʱ";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.at.max + "ms";
                    
                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.at.min + "ms";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.at.avg + "ms";

                    cell = trow.insertCell(pos++); 
                    cell.innerHTML = _npm.at.ret;
                    
                    box.appendChild(tab);
                    document.getElementById("showResult_box").appendChild(box);
                }
                
                /*
                for(var x = 0; x < i; x++) {
                    table.init('tab_npmdata'+x, {
                        skin: 'line'
                        ,size: 'sm'
                    }); 
                }

                box = document.createElement("div");
                box.setAttribute('class', 'layui-row');
                box.innerHTML = "ӣƽ" + ret.allcnt.avg +"ֵ" + ret.allcnt.max;
                document.getElementById("showResult_box").appendChild(box);

                box = document.createElement("div");
                box.setAttribute('class', 'layui-row');
                box.innerHTML = "ƽ" + ret.rate.out_avg +"ֵ" + ret.rate.out_max;
                document.getElementById("showResult_box").appendChild(box);
                
                box = document.createElement("div");
                box.setAttribute('class', 'layui-row');
                box.innerHTML = "ƽ" + ret.rate.in_avg +"ֵ" + ret.rate.in_max;
                document.getElementById("showResult_box").appendChild(box);
                */
            },
        });
    }
    
    function IsDigit(str)
    {
        if (str == "") return false;

        var i = 0
        if (str.charAt(0) == '-') 
        i = 1

        for (; i < str.length; i++) {
            if (str.charAt(i) < '0' || str.charAt(i) > '9')
                return false;
        }
        return true;
    }
    
    window.setboxHeight = function() {
        var height = window.parent.document.documentElement.clientHeight - 350;
        var obj = document.getElementById("showResult_box");
        obj.style.height = height +"px";   
    }
    
    loadConf();
    loadRet();
    setboxHeight();
    window.setInterval(loadRet, 20000);
    $("#my-shade").remove();
});
