/* first create by zhang.ruikang, thanks layui */

layui.use(['element', 'form', 'table'], function(){
    var $ = layui.$;
    var element = layui.element;
    var form = layui.form;
    var table = layui.table;
    var api = "/cgi-bin/App/opser/pingmonitor";
    
    table.render({
        elem: '#pingif_list'
        ,loading: false
        ,cellMinWidth: 80
        ,size: 'sm'
        ,url: api+'?action=load_pinglist' 
        ,cols: [[
            {type: 'checkbox'}
            ,{field: 'host_desc', title: 'ע', unresize: true}
            ,{field: 'host_ip', title: 'IP/', width: 160, unresize: true}
            ,{field: 'pxy_name', title: 'PINGӿ', unresize: true}       
            ,{field: 'pxy_id', title: '·ID', hide: true, unresize: true}       
            ,{field: 'cur_ms', title: 'ǰʱMS', width: 115, unresize: true, sort: true, templet: '#Tpltimeout'}
            ,{field: 'avg_ms', title: 'ƽʱMS', width: 115, unresize: true, sort: true}
            ,{field: 'max_ms', title: 'ʱMS', width: 115, unresize: true, sort: true}
            ,{field: 'misspkt', title: 'ʡ',  width: 100, unresize: true, sort: true}
            ,{title: '<a class="layui-btn layui-btn-xs layui-btn-normal" id="pinglist_add"></a>\
            <a class="layui-btn layui-btn-xs layui-btn-danger" id="ping_del">ɾ</a>'
            ,align:'right', toolbar: '#tabtools', width: 120, unresize: true}
        ]]
    });

    table.on('tool(pingif_list)', function(obj){
        var data = obj.data;
        var layEvent = obj.event;
        if(layEvent === "log"){
            layer.open({
                title: '־'+data.pxy_name+'  PING  '+data.host_ip
                ,area: ['600px', '500px']
                ,type: 1
                ,anim: 1
                ,shadeClose: true
                ,content: $("#box_showPingLog").html()
            }); 
            table.render({
                elem: '#ping_log'
                ,loading: false
                ,cellMinWidth: 80
                ,size: 'sm'
                ,url: api+'?action=load_pinglog&desc='+data.host_desc 
                ,cols: [[
                    {type: 'numbers', title: '', unresize: true, width:60}
                    ,{field: 'time', title: 'ʱ', unresize: true}
                    ,{field: 'desc', title: 'ע', unresize: true, width:180}
                    ,{field: 'event', title: '¼', unresize: true, width:100}       
                ]]
            });
        } else
        if(layEvent === "del"){
            layer.confirm('ȷҪɾ', {icon: 3, title:"ʾ"}, 
            function(index) {
                row = data.host_desc + "_" + data.host_ip + "_" + 
                    data.pxy_id + "_" + data.pxy_name;
                var uri = "?action=del_pinglist&data="+row;
                AJXS({
                    type: 'POST',
                    url: api + uri,
                    error: function(status){
                        layer.closeAll();
                        layer.msg("Ǹʧ", {icon:2, anim: 6}); 
                    },
                    success: function(data) {
                        layer.closeAll();
                        data = eval('('+data+')');

                        if(data.code == 1)
                            layer.msg(data.msg, {icon:2, anim: 6});
                        else {
                            layer.msg(data.msg, {icon:1});
                            table.reloadExt("pingif_list");
                            load_status();
                        }
                    }
                });
            });
        }
    });

    $("#ping_del").click(function(){
        var checkStatus = table.checkStatus('pingif_list');
        var data = checkStatus.data;
        if ( data.length == 0 ){
            layer.msg("ǰδѡκ", {icon: 2, anim: 6});
            return false;
        }

        layer.confirm('ȷҪɾѡ', {icon: 3, title:"ʾ"}, 
        function(index) {
            var list = new Array();
            for(var i = 0; i <= (data.length-1); i++){
                row = data[i].host_desc + "_" + data[i].host_ip + "_" + 
                    data[i].pxy_id + "_" + data[i].pxy_name;
                list.push(row);
            }
            var uri = "?action=del_pinglist&data="+list.toString();
            AJXS({
                type: 'POST',
                url: api + uri,
                error: function(status){
                    layer.closeAll();
                    layer.msg("Ǹʧ", {icon:2, anim: 6}); 
                },
                success: function(data) {
                    layer.closeAll();
                    data = eval('('+data+')');
                    
                    if(data.code == 1)
                        layer.msg(data.msg, {icon:2, anim: 6});
                    else {
                        layer.msg(data.msg, {icon:1});
                        table.reloadExt("pingif_list");
                        load_status();
                    }
                }
            });
        });
    });

    $("#pinglist_add").click(function(){
        layer.open({
            title: 'PING'
            ,area: ['600px', '500px']
            ,type: 2
            ,anim: 1
            ,shadeClose: true
            ,content: 'popup/pop_pingmonitor.html'
        }); 
    });

    form.on('switch(btn_enable)', function(data){
        AJXS({
            type: 'POST',
            url: api + '?action=ping_enable&enable=' + data.elem.checked,
            error: function(status){
                layer.msg("Ǹʧ", {icon:2, anim: 6}); 
            },
            success: function(data) {
                data = eval('('+data+')');
                if(data.code == 1)
                    layer.msg(data.msg, {icon:2, anim: 6});
                else {
                    layer.msg(data.msg, {icon:1});
                    load_status();
                }
            }
        });
    });

    function load_status(){
        AJXS({
            type: 'POST',
            url: api + '?action=ping_load',
            error: function(status){},
            success: function(data) {
                data = eval('('+data+')');
                if(data.data.server == "run"){
                    var times = data.data.startime == "" ? "..." : data.data.startime;
                    var count = data.data.pingtime == "" ? "..." : data.data.pingtime;
                    $("#show_time").html('ʱ䣺<span style="color:blue">'+times+'</span>');
                    $("#show_count").html('PING<span style="color:blue">'+count+'</span>');
                    $("#show_time").show();
                    $("#show_count").show();
                    $("#btn_enable")[0].checked = true;
                    form.render();
                }else {
                    $("#show_time").hide();
                    $("#show_count").hide();
                    $("#btn_enable")[0].checked = false;
                    form.render();
                }
            }
        });
    }
    
    var auto_refresh_hd = 0;
    form.on('select(auto-refresh)', function(data){
        window.clearInterval(auto_refresh_hd);
        if(data.value != 0)
            auto_refresh_hd = window.setInterval(upgrade_tab, Number(data.value)*1000);
    });
    
    function autoRefresh(){
        load_status();
        upgrade_tab();
    }
    
    function upgrade_tab(){
        table.reloadExt("pingif_list");
        load_status();
    }

    window.setboxHeight = function(){
        var height = window.parent.document.documentElement.clientHeight - 280;
        var obj = document.getElementById("pingif_box");
        obj.style.height = height +"px";   
    }

    setboxHeight();
	load_status();
    auto_refresh_hd = window.setInterval(autoRefresh, 5000);
    $("#my-shade").remove();
});
